Index: drivers/filesystems/btrfs/worker-thread.c
===================================================================
--- drivers/filesystems/btrfs/worker-thread.c	(révision 74430)
+++ drivers/filesystems/btrfs/worker-thread.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 74430)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -24,22 +24,26 @@
     UINT64 start;
     UINT64 end;
     UINT8* data;
-    UINT32 skip_start;
-    UINT32 skip_end;
+    PMDL mdl;
+    UINT32 irp_offset;
 } write_stripe;
 
-typedef struct {
-    LONG stripes_left;
-    KEVENT event;
-} read_stripe_master;
+struct _read_context;
 
 typedef struct {
     PIRP Irp;
-    PDEVICE_OBJECT devobj;
     IO_STATUS_BLOCK iosb;
-    read_stripe_master* master;
-} read_stripe;
+    device* dev;
+    struct _read_context* context;
+} read_context_stripe;
 
+typedef struct _read_context {
+    KEVENT Event;
+    ULONG total;
+    LONG left;
+    read_context_stripe* stripes;
+} read_context;
+
 // static BOOL extent_item_is_shared(EXTENT_ITEM* ei, ULONG len);
 static NTSTATUS STDCALL write_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr);
 static void remove_fcb_extent(fcb* fcb, extent* ext, LIST_ENTRY* rollback);
@@ -46,6 +50,7 @@
 
 extern tPsUpdateDiskCounters PsUpdateDiskCounters;
 extern tCcCopyWriteEx CcCopyWriteEx;
+extern tFsRtlUpdateDiskCounters FsRtlUpdateDiskCounters;
 extern BOOL diskacc;
 
 BOOL find_data_address_in_chunk(device_extension* Vcb, chunk* c, UINT64 length, UINT64* address) {
@@ -54,6 +59,18 @@
     
     TRACE("(%p, %llx, %llx, %p)\n", Vcb, c->offset, length, address);
     
+    if (length > c->chunk_item->size - c->used)
+        return FALSE;
+    
+    if (!c->cache_loaded) {
+        NTSTATUS Status = load_cache_chunk(Vcb, c, NULL);
+        
+        if (!NT_SUCCESS(Status)) {
+            ERR("load_cache_chunk returned %08x\n", Status);
+            return FALSE;
+        }
+    }
+    
     if (IsListEmpty(&c->space_size))
         return FALSE;
     
@@ -246,7 +263,7 @@
     return TRUE;
 }
 
-static BOOL find_new_stripe(device_extension* Vcb, stripe* stripes, UINT16 i, UINT64 max_stripe_size, UINT16 type) {
+static BOOL find_new_stripe(device_extension* Vcb, stripe* stripes, UINT16 i, UINT64 max_stripe_size) {
     UINT64 k, devusage = 0xffffffffffffffff;
     space* devdh = NULL;
     LIST_ENTRY* le;
@@ -453,7 +470,7 @@
             num_stripes = max_stripes;
     } else {
         for (i = 0; i < max_stripes; i++) {
-            if (!find_new_stripe(Vcb, stripes, i, max_stripe_size, type))
+            if (!find_new_stripe(Vcb, stripes, i, max_stripe_size))
                 break;
             else
                 num_stripes++;
@@ -552,10 +569,12 @@
     c->size = cisize;
     c->offset = logaddr;
     c->used = c->oldused = 0;
-    c->cache = NULL;
+    c->cache = c->old_cache = NULL;
     c->readonly = FALSE;
     c->reloc = FALSE;
     c->last_alloc_set = FALSE;
+    c->last_stripe = 0;
+    c->cache_loaded = TRUE;
     
     InitializeListHead(&c->space);
     InitializeListHead(&c->space_size);
@@ -563,7 +582,7 @@
     InitializeListHead(&c->changed_extents);
     
     InitializeListHead(&c->range_locks);
-    KeInitializeSpinLock(&c->range_locks_spinlock);
+    ExInitializeResourceLite(&c->range_locks_lock);
     KeInitializeEvent(&c->range_locks_event, NotificationEvent, FALSE);
     
     ExInitializeResourceLite(&c->lock);
@@ -585,7 +604,7 @@
     for (i = 0; i < num_stripes; i++) {
         stripes[i].device->devitem.bytes_used += stripe_size;
         
-        space_list_subtract2(Vcb, &stripes[i].device->space, NULL, cis[i].offset, stripe_size, NULL);
+        space_list_subtract2(&stripes[i].device->space, NULL, cis[i].offset, stripe_size, NULL, NULL);
     }
     
     success = TRUE;
@@ -631,11 +650,14 @@
     return success ? c : NULL;
 }
 
-static NTSTATUS prepare_raid0_write(chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes) {
+static NTSTATUS prepare_raid0_write(chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes, PIRP Irp, UINT32 irp_offset, write_data_context* wtc) {
     UINT64 startoff, endoff;
     UINT16 startoffstripe, endoffstripe, stripenum;
     UINT64 pos, *stripeoff;
     UINT32 i;
+    BOOL file_write = Irp && Irp->MdlAddress && (Irp->MdlAddress->ByteOffset == 0);
+    PMDL master_mdl;
+    PFN_NUMBER* pfns;
     
     stripeoff = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64) * c->chunk_item->num_stripes, ALLOC_TAG);
     if (!stripeoff) {
@@ -646,28 +668,64 @@
     get_raid0_offset(address - c->offset, c->chunk_item->stripe_length, c->chunk_item->num_stripes, &startoff, &startoffstripe);
     get_raid0_offset(address + length - c->offset - 1, c->chunk_item->stripe_length, c->chunk_item->num_stripes, &endoff, &endoffstripe);
     
+    if (file_write) {
+        master_mdl = Irp->MdlAddress;
+        
+        pfns = (PFN_NUMBER*)(Irp->MdlAddress + 1);
+        pfns = &pfns[irp_offset >> PAGE_SHIFT];
+    } else if (((ULONG_PTR)data % PAGE_SIZE) != 0) {
+        wtc->scratch = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+        if (!wtc->scratch) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        RtlCopyMemory(wtc->scratch, data, length);
+        
+        master_mdl = IoAllocateMdl(wtc->scratch, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        MmBuildMdlForNonPagedPool(master_mdl);
+        
+        wtc->mdl = master_mdl;
+        
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+    } else {
+        master_mdl = IoAllocateMdl(data, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        MmProbeAndLockPages(master_mdl, KernelMode, IoReadAccess);
+        
+        wtc->mdl = master_mdl;
+        
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+    }
+    
     for (i = 0; i < c->chunk_item->num_stripes; i++) {
-        if (startoffstripe > i) {
+        if (startoffstripe > i)
             stripes[i].start = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (startoffstripe == i) {
+        else if (startoffstripe == i)
             stripes[i].start = startoff;
-        } else {
+        else
             stripes[i].start = startoff - (startoff % c->chunk_item->stripe_length);
-        }
         
-        if (endoffstripe > i) {
+        if (endoffstripe > i)
             stripes[i].end = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (endoffstripe == i) {
+        else if (endoffstripe == i)
             stripes[i].end = endoff + 1;
-        } else {
+        else
             stripes[i].end = endoff - (endoff % c->chunk_item->stripe_length);
-        }
         
         if (stripes[i].start != stripes[i].end) {
-            stripes[i].data = ExAllocatePoolWithTag(NonPagedPool, stripes[i].end - stripes[i].start, ALLOC_TAG);
-            
-            if (!stripes[i].data) {
-                ERR("out of memory\n");
+            stripes[i].mdl = IoAllocateMdl(NULL, stripes[i].end - stripes[i].start, FALSE, FALSE, NULL);
+            if (!stripes[i].mdl) {
+                ERR("IoAllocateMdl failed\n");
                 ExFreePool(stripeoff);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
@@ -678,23 +736,28 @@
     RtlZeroMemory(stripeoff, sizeof(UINT64) * c->chunk_item->num_stripes);
     
     stripenum = startoffstripe;
+    
     while (pos < length) {
+        PFN_NUMBER* stripe_pfns = (PFN_NUMBER*)(stripes[stripenum].mdl + 1);
+        
         if (pos == 0) {
             UINT32 writelen = min(stripes[stripenum].end - stripes[stripenum].start,
-                                  c->chunk_item->stripe_length - (stripes[stripenum].start % c->chunk_item->stripe_length));
+                                    c->chunk_item->stripe_length - (stripes[stripenum].start % c->chunk_item->stripe_length));
             
-            RtlCopyMemory(stripes[stripenum].data, data, writelen);
+            RtlCopyMemory(stripe_pfns, pfns, writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            
             stripeoff[stripenum] += writelen;
             pos += writelen;
         } else if (length - pos < c->chunk_item->stripe_length) {
-            RtlCopyMemory(stripes[stripenum].data + stripeoff[stripenum], (UINT8*)data + pos, length - pos);
+            RtlCopyMemory(&stripe_pfns[stripeoff[stripenum] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (length - pos) * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
             break;
         } else {
-            RtlCopyMemory(stripes[stripenum].data + stripeoff[stripenum], (UINT8*)data + pos, c->chunk_item->stripe_length);
+            RtlCopyMemory(&stripe_pfns[stripeoff[stripenum] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            
             stripeoff[stripenum] += c->chunk_item->stripe_length;
             pos += c->chunk_item->stripe_length;
         }
-        
+    
         stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
     }
 
@@ -703,11 +766,14 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS prepare_raid10_write(chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes) {
+static NTSTATUS prepare_raid10_write(chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes, PIRP Irp, UINT32 irp_offset, write_data_context* wtc) {
     UINT64 startoff, endoff;
     UINT16 startoffstripe, endoffstripe, stripenum;
     UINT64 pos, *stripeoff;
     UINT32 i;
+    BOOL file_write = Irp && Irp->MdlAddress && (Irp->MdlAddress->ByteOffset == 0);
+    PMDL master_mdl;
+    PFN_NUMBER* pfns;
 
     stripeoff = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64) * c->chunk_item->num_stripes / c->chunk_item->sub_stripes, ALLOC_TAG);
     if (!stripeoff) {
@@ -720,40 +786,75 @@
 
     startoffstripe *= c->chunk_item->sub_stripes;
     endoffstripe *= c->chunk_item->sub_stripes;
+    
+    if (file_write) {
+        master_mdl = Irp->MdlAddress;
+        
+        pfns = (PFN_NUMBER*)(Irp->MdlAddress + 1);
+        pfns = &pfns[irp_offset >> PAGE_SHIFT];
+    } else if (((ULONG_PTR)data % PAGE_SIZE) != 0) {
+        wtc->scratch = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+        if (!wtc->scratch) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        RtlCopyMemory(wtc->scratch, data, length);
+        
+        master_mdl = IoAllocateMdl(wtc->scratch, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        MmBuildMdlForNonPagedPool(master_mdl);
+        
+        wtc->mdl = master_mdl;
+        
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+    } else {
+        master_mdl = IoAllocateMdl(data, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        MmProbeAndLockPages(master_mdl, KernelMode, IoReadAccess);
+        
+        wtc->mdl = master_mdl;
+        
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+    }
 
     for (i = 0; i < c->chunk_item->num_stripes; i += c->chunk_item->sub_stripes) {
         UINT16 j;
         
-        if (startoffstripe > i) {
+        if (startoffstripe > i)
             stripes[i].start = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (startoffstripe == i) {
+        else if (startoffstripe == i)
             stripes[i].start = startoff;
-        } else {
+        else
             stripes[i].start = startoff - (startoff % c->chunk_item->stripe_length);
-        }
         
-        if (endoffstripe > i) {
+        if (endoffstripe > i)
             stripes[i].end = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (endoffstripe == i) {
+        else if (endoffstripe == i)
             stripes[i].end = endoff + 1;
-        } else {
+        else
             stripes[i].end = endoff - (endoff % c->chunk_item->stripe_length);
+
+        stripes[i].mdl = IoAllocateMdl(NULL, stripes[i].end - stripes[i].start, FALSE, FALSE, NULL);
+        if (!stripes[i].mdl) {
+            ERR("IoAllocateMdl failed\n");
+            ExFreePool(stripeoff);
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        if (stripes[i].start != stripes[i].end) {
-            stripes[i].data = ExAllocatePoolWithTag(NonPagedPool, stripes[i].end - stripes[i].start, ALLOC_TAG);
-            
-            if (!stripes[i].data) {
-                ERR("out of memory\n");
-                ExFreePool(stripeoff);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-        }
-        
         for (j = 1; j < c->chunk_item->sub_stripes; j++) {
             stripes[i+j].start = stripes[i].start;
             stripes[i+j].end = stripes[i].end;
             stripes[i+j].data = stripes[i].data;
+            stripes[i+j].mdl = stripes[i].mdl;
         }
     }
 
@@ -761,23 +862,28 @@
     RtlZeroMemory(stripeoff, sizeof(UINT64) * c->chunk_item->num_stripes / c->chunk_item->sub_stripes);
 
     stripenum = startoffstripe / c->chunk_item->sub_stripes;
+    
     while (pos < length) {
+        PFN_NUMBER* stripe_pfns = (PFN_NUMBER*)(stripes[stripenum * c->chunk_item->sub_stripes].mdl + 1);
+        
         if (pos == 0) {
             UINT32 writelen = min(stripes[stripenum * c->chunk_item->sub_stripes].end - stripes[stripenum * c->chunk_item->sub_stripes].start,
-                                  c->chunk_item->stripe_length - (stripes[stripenum * c->chunk_item->sub_stripes].start % c->chunk_item->stripe_length));
+                                    c->chunk_item->stripe_length - (stripes[stripenum * c->chunk_item->sub_stripes].start % c->chunk_item->stripe_length));
             
-            RtlCopyMemory(stripes[stripenum * c->chunk_item->sub_stripes].data, data, writelen);
+            RtlCopyMemory(stripe_pfns, pfns, writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            
             stripeoff[stripenum] += writelen;
             pos += writelen;
         } else if (length - pos < c->chunk_item->stripe_length) {
-            RtlCopyMemory(stripes[stripenum * c->chunk_item->sub_stripes].data + stripeoff[stripenum], (UINT8*)data + pos, length - pos);
+            RtlCopyMemory(&stripe_pfns[stripeoff[stripenum] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (length - pos) * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
             break;
         } else {
-            RtlCopyMemory(stripes[stripenum * c->chunk_item->sub_stripes].data + stripeoff[stripenum], (UINT8*)data + pos, c->chunk_item->stripe_length);
+            RtlCopyMemory(&stripe_pfns[stripeoff[stripenum] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            
             stripeoff[stripenum] += c->chunk_item->stripe_length;
             pos += c->chunk_item->stripe_length;
         }
-        
+
         stripenum = (stripenum + 1) % (c->chunk_item->num_stripes / c->chunk_item->sub_stripes);
     }
 
